package provide cmd_tools 1.0
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2000
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################
set rev(parseArgs.tcl) {$Header: /home/clif/CVS_ROOT/Tools/parseArgs.tcl,v 1.7 2000/07/24 16:29:45 clif Exp $}


################################################################
# proc parseArgs {stateVar {throwError 1}}--
#    Parses $argv into a state array.
#    looks for arguments of the form -key val1 ?val2 ... valn?
#    and assigns them as ArrayName(key) "val1 ?val2 ... valn?"
#     Keys must have a default value to be assigned.
#     By default, an error is thrown if an undefaulted key is found.
#     If throwError == 0, then the undefaulted keays are appended
#        into a list of errors, which will be returned.
# Arguments
#   stateVar	The name of the associative array to have key/values set
#   throwError	Optional 0 to turn off errors and return a list.
# 
# Results
#   Any default values in stateVar are replaced with new values from the
#       command line.
# 

proc parseArgs {stateVar {throwError 1}} {
    global argv
    upvar $stateVar stateArray

    set errs ""
    
    foreach arg $argv {
        if {![string first "-" $arg]} {  
            set index [string range $arg 1 end]
            if {![info exists stateArray($index)]} {
	        if {$throwError} {
	            error "No default for ${stateVar}($index)"
		} else {
		    lappend errs "No default for ${stateVar}($index)"
		}
	    }
	    set cmd set
	} else {
	    if {[info exists cmd]} {
                $cmd stateArray($index) $arg
	        set cmd lappend
	    }
	}
    }
    return $errs
}

